                                                                                                                                                                                                                                                                 /*************************************
 * Adconverter.h
 *   
 * : 10.06.2022 16:20:03
 * :  .
 *************************************/

#pragma once

#include "Main.h"

#define ADCSECOND_CURRCHARGE 0 //     2 
#define ADCSECOND_CURRDISCHARGE 1 //     2 
#define ADCFIRST_CURRCHARGE 2 //     1 
#define ADCFIRST_CURRDISCHARGE 3 //     1 
#define ADCFIRST_VOLTAGE 6 //    1 
#define ADCSECOND_VOLTAGE 7 //    2 
#define ADCOFFSET_AGND 31 //    
#define ADCBASE_REFTYPE 0 //   
#define ADCAREF_VOLTAGE 1100 //   
#define ADCMODE_DATA 135 //     125  
#define ADCNIMHCD_DIVIDER 2000 //      Ni-Cd  Ni-Mh  
#define ADCNIZN_DIVIDER 2167 //      Ni-Zn   
#define ADCLITHIUM1_DIVIDER 4533 //      Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
#define ADCLITHIUM2_DIVIDER 3767 //      Li-Fe  
#define ADCLITHIUM3_DIVIDER 2933 //      Li-Ti  
#define ADCSLA2V_DIVIDER 2600 //      Sla-2v  
#define ADCSLA4V_DIVIDER 5500 //      Sla-4v  
#define ADCSLA6V_DIVIDER 7500 //      Sla-6v  
#define ADCSLA12V_DIVIDER 14500 //      Sla-12v  
#define ADCLIFEPO4_DIVIDER 14500 //      LiFePo4  
#define ADC2NIMH_DIVIDER 3767 //        2- Ni-Mh  
#define ADC3NIMH_DIVIDER 5500 //        3- Ni-Mh  
#define ADC4NIMH_DIVIDER 7500 //        4- Ni-Mh  
#define ADC5NIMH_DIVIDER 8833 //        5- Ni-Mh  
#define ADC6NIMH_DIVIDER 10500 //        6- Ni-Mh  
#define ADC7NIMH_DIVIDER 12500 //        7- Ni-Mh  
#define ADC8NIMH_DIVIDER 14500 //        8- Ni-Mh  
#define ADCMEASCUR_RESISTOR 4700 //     0,47  
#define ADCLIMIT_NIMHCD 2100 //     Ni-Cd  Ni-Mh  
#define ADCLIMIT_NIZN 2275 //     Ni-Zn  
#define ADCLIMIT_LITHIUM1 4760 //     Li-Po,Li-Ion,Li-Mn,Li-Co,Li-Nca,Li-Nmc  
#define ADCLIMIT_LITHIUM2 3955 //     Li-Fe  
#define ADCLIMIT_LITHIUM3 3080 //     Li-Ti  
#define ADCLIMIT_2NIMH 3955 //       2- Ni-Mh   
#define ADCLIMIT_3NIMH 5800 //       3- Ni-Mh   
#define ADCLIMIT_4NIMH 7900 //       4- Ni-Mh 
#define ADCLIMIT_5NIMH 9300 //       5- Ni-Mh 
#define ADCLIMIT_6NIMH 11100 //       6- Ni-Mh 
#define ADCLIMIT_7NIMH 13200 //       7- Ni-Mh 
#define ADCLIMIT_8NIMH 15300 //       8- Ni-Mh 
#define ADCLIMIT_SLA2V 2800 //     Sla-2v 
#define ADCLIMIT_SLA4V 5500 //     Sla-4v 
#define ADCLIMIT_SLA6V 8000 //     Sla-6v 
#define ADCLIMIT_SLA12V 16000 //     Sla-12v 
#define ADCLIMIT_LIFEPO4 14600 //     LiFePo4 
#define ADCLIMIT_CURRENT 2300 //  /  

// 
void ADC_InitializeDevice(void); //   
void ADC_UpdateDivider(byte numbersensor_prm,word divisionfactor_prm); //    
void ADC_DefaultDivider(byte numbersensor_prm); //      
void ADC_UpdateResistance(byte countmodecalibrate_prm,dword measuredvaluesdata_prm); //    
void ADC_DefaultResistance(byte countmodecalibrate_prm); //       
word ADC_ReadMeasuredata(byte measureinput_prm); //    
word ADC_AverageMeasuredata(byte numbercycle_prm,byte measureinput_prm); //      
word ADC_MeasureVoltage(byte numbercycle_prm,byte measureinput_prm); //   
word ADC_MeasureCurrent(byte numbercycle_prm,byte measureinput_prm); //   
word ADC_ReadingDivider(byte numbersensor_prm); //     
word ADC_OffsetMeasure(void); //     
dword ADC_ReadingParameters(byte numberparameters_prm); //         





