/****************************************************
 * Keybuttscan.c
 *     
 * : 04.08.2021 11:11:43
 * :  .
 *****************************************************/

#include <avr/io.h>
#include <avr/sfr_defs.h>
#include <util/delay_basic.h>
#include "Main.h"
#include "Keybuttscan.h"
#include "Systemcontrol.h"

bit_key indx_key={0}; //   

byte KEY_ScanningButton(void) //   
	{
	bit indxoutcycle_tmp=FALSE; //  
	byte scanningcode_tmp=0; 
	byte counterscannig_tmp=0;
	KEYSCANN_BUTTON=KEYDATA_INITIAL; //    
	while(indxoutcycle_tmp==FALSE) //   
		{
		switch(counterscannig_tmp) //   
			{
			case 0: ClearBit(KEYSCANN_BUTTON,KEYFIRST_GROUP); //   
					_delay_loop_2(40); // 10  
					if((bit_is_clear(KEYGROUP1_BUTTON,KEYIN_BYTE1))||(bit_is_clear(KEYGROUP2_BUTTON,KEYIN_BYTE2))) //   L  R 
						{
						SYS_TimeWaiting(20); // 20  
						if((bit_is_clear(KEYGROUP1_BUTTON,KEYIN_BYTE1))||(bit_is_clear(KEYGROUP2_BUTTON,KEYIN_BYTE2))) //    
							{
							if(bit_is_clear(KEYGROUP1_BUTTON,KEYIN_BYTE1)) scanningcode_tmp=1; //   L 
							else if(bit_is_clear(KEYGROUP2_BUTTON,KEYIN_BYTE2)) scanningcode_tmp=2; //   R 
							indxoutcycle_tmp=TRUE; //      
							}
						}
					if(indxoutcycle_tmp==FALSE) counterscannig_tmp++; //          
					SetBit(KEYSCANN_BUTTON,KEYFIRST_GROUP); //    
					break;
			case 1: ClearBit(KEYSCANN_BUTTON,KEYSECOND_GROUP); //   
					_delay_loop_2(40); // 10 
					if(bit_is_clear(KEYGROUP2_BUTTON,KEYIN_BYTE2)) //   Enter 
						{
						SYS_TimeWaiting(20); // 20 
						if(bit_is_clear(KEYGROUP2_BUTTON,KEYIN_BYTE2)) //    
							{
							scanningcode_tmp=5; //   Enter 
							indxoutcycle_tmp=TRUE; //      
							}
						}
					if(indxoutcycle_tmp==FALSE) counterscannig_tmp++; //          
					SetBit(KEYSCANN_BUTTON,KEYSECOND_GROUP); //     
					break;
			case 2: ClearBit(KEYSCANN_BUTTON,KEYTHIRD_GROUP); //   
					_delay_loop_2(40); // 10 
					if((bit_is_clear(KEYGROUP1_BUTTON,KEYIN_BYTE1))||(bit_is_clear(KEYGROUP2_BUTTON,KEYIN_BYTE2))) //   U  D 
						{
						SYS_TimeWaiting(20); // 20 
						if((bit_is_clear(KEYGROUP1_BUTTON,KEYIN_BYTE1))||(bit_is_clear(KEYGROUP2_BUTTON,KEYIN_BYTE2))) //    
							{
							if(bit_is_clear(KEYGROUP1_BUTTON,KEYIN_BYTE1)) scanningcode_tmp=4; //   D 
							else if(bit_is_clear(KEYGROUP2_BUTTON,KEYIN_BYTE2)) scanningcode_tmp=3; //   U 
							}
						}
					SetBit(KEYSCANN_BUTTON,KEYTHIRD_GROUP); //    
					indxoutcycle_tmp=TRUE; //      
			}
		}
	return scanningcode_tmp; //   
	}

byte KEY_DecoderButton(void) //     
	{
	byte outbuttoncode_tmp=0; // 
	byte outscanningcode_tmp=0; 
	switch(indx_key.switcherscanning) //  / 
		{
		case FALSE: outscanningcode_tmp=KEY_ScanningButton(); //      
					if(outscanningcode_tmp>0) //  
						{
						indx_key.switcherscanning=TRUE; //     
						outbuttoncode_tmp=outscanningcode_tmp; //     
						SYS_OutsignalBeep(10,1); //    10 
						}
					break;
		case TRUE: outscanningcode_tmp=KEY_ScanningButton(); //      
					if(outscanningcode_tmp==0) //   
						{
						SYS_TimeWaiting(20); // 20 
						outscanningcode_tmp=KEY_ScanningButton(); //   
						if(outscanningcode_tmp==0) indx_key.switcherscanning=FALSE; //      
						}
		}
	return outbuttoncode_tmp; //    ,    
	}







