/*******************************************************
* Lcdworkunit.h
*     LCD  WH1601L
* : 10.06.2022 10:24:41
* :  .
*******************************************************/

#pragma once

#include "Main.h"

#define LCD_GotoPosition(spotposition) LCD_SetpositionCursor(spotposition); //     
#define LCDOUT_DATA PORTD //   LCD
#define LCDOUT_DIRECT DDRD //    LCD
#define LCDIN_DATA PIND //    LCD
#define LCDOUT_BYTE0 PORTD0 //  0
#define LCDOUT_BYTE1 PORTD1 //  1
#define LCDOUT_BYTE2 PORTD2 //  2
#define LCDOUT_BYTE3 PORTD3 //  3
#define LCDOUT_RS PORTD5 //  /
#define LCDOUT_RW PORTD6 //  /
#define LCDOUT_EN PORTD7 //  / 
#define LCDIN_BYTE0 PIND0 //  0 
#define LCDIN_BYTE1 PIND1 //  1 
#define LCDIN_BYTE2 PIND2 //  2 
#define LCDIN_BYTE3 PIND3 //  3 
#define WAIT_FLAG 7 //   LCD

void LCD_InitializeDevice(void); //  LCD
void LCD_WriteData(byte outputdata_prm); //     LCD
void LCD_WriteCommon(byte outputcommon_prm); //    LCD
void LCD_SetbyteData(byte outputdata_prm); //       LCD
void LCD_CommonFunction(byte commondata_prm); //   LCD  4- 
void LCD_WaitDevice(void); //   LCD
void LCD_SetpositionCursor(byte spotpositioncursor_prm); //   
byte LCD_SwapNibbles(byte numberdata_prm); //    

