/**********************************************
* Systemcontrol.h
*    
* : 10.06.2022 17:39:53
* :  .
***********************************************/

#pragma once

#include "Main.h"

#define SYSCONTROL_BEEP PORTC //    
#define SYSOUTBIT_BEEP PORTC0 //    
#define SYSFREQU_PIEZO 6800 //    
#define SYSFREQU_CRYSTAL 16000000 //    

typedef struct
	{
	byte counteroperating; //   
	byte updatelinemode; //     
	}var_sys;

void SYS_TimeWaiting(word milliseconds_prm); //     
void SYS_InitializeBeep(void); //   
void SYS_OutsignalBeep(byte durationofbeep_prm,byte numbersignals_prm); //         
void SYS_MainMode(void); //  
void SYS_SwitchWorkmode(void); //    
void SYS_InitializePwmcontrol(void); //   
